public class Aufgabe1 {

    private int counter;
    private int max;
    private int overflowCounter;


    /**
     * • Wozu benötigt man Klassen?
     *
     *  Klassen werden zur Kapselung von Daten verwendet. Mit Methoden, die diese Klassen bereitstellen, können
     *  die gekapselten Daten über eine definierte Schnittstelle verändert werden. Eine Klasse kann man auch als
     *  eigenen Datentyp sehen.
     *
     *  • Wie unterscheiden sich Objekte von Klassen?
     *
     *  Ein Objekt ist eine instantiierte Klasse. Eine Klasse könnte man als Objektschablone bezeichnen. Ein Objekt
     *  existiert nur zur Laufzeit.
     *
     *  • Warum benötigt man einen Konstruktor?
     *
     *  Ein Konstruktor initialisiert ein Objekt. Es
     *
     *  • Wann verwendet man private und wann public?
     *
     *  public und private regeln die Sichtbarkeit von Methoden, Klassen, etc. Ziel einer Software-Architektur soll
     *  sein, dass nur so wenig Schnittstellen nach außen (public) offen gelegt werden und alle Eigenschaften soweit
     *  möglich private sind. Dies fördert das Prinzip der losen Kopplung.
     *
     *  • Wie unterscheiden sich this und this() voneinander?
     *
     *  this ist ein Schlüsselwort (Keyword) und wird verwendet, um auf eine Instanz von sich selbst (also das Objekt
     *  der Klasse) zugreifen zu können.
     *
     *  Mit this() wiederum wird von einem Konstruktor aus ein anderer Konstruktor aufgerufen. Dieser kann z.B.
     *  andere Parameter haben (Method overloading) oder einer Superklasse angehören.
     */

    /**
     * Initialize counter with biggest possible value.
     *
     * If the counter is incremented so that it will exceed max, overflowCounter will be increased by one
     * and the counter will be reset.
     *
     * @param max Maximum value that can be expressed with this counter.
     */
    public Aufgabe1(int max) {
        this.max = max;
        this.counter = 0;
        this.overflowCounter = 0;

    }

    /**
     * Returns the number of overflows that have happened.
     *
     * An overflow happens if the counter is incremented beyond the max threshold.
     *
     * @return Number of overflows
     */
    public int getOverflowCounter() {
        return overflowCounter;
    }

    /**
     * Returns the internal counter.
     *
     * The state of the internal counter is returned. To modify the counter the methods reset() and increment() must be
     * used.
     *
     * @return The internal counter value
     */
    public int getCounter() {
        return counter;
    }

    /**
     * Reset the counter and the overflow counter.
     */
    public void reset() {
        counter = 0;
        overflowCounter = 0;
    }

    /**
     * Increment the counter by one and detect if an overflow happened.
     *
     * If an overflow happened counter will be set to and the overflow counter state will be increased.
     */
    public void increment() {
        counter++;

        if (counter == max) {
            overflowCounter++;
            counter = 0;
        }
    }
}
