import java.util.HashMap;

public class Aufgabe2 {

    /**
     * • Sowohl Klassen als auch Arrays beinhalten Daten. Wie unterscheiden sich aber Klassen von Arrays?
     *
     * Arrays können nur Daten von einem bestimmten Typ speichern und bieten auch keine Schnittstellen an, um auf diese
     * Daten zu operieren. In Klassen hingegen können beliebige Daten gespeichert werden.
     *
     * • Wie unterscheidet sich ein Array von einer Map?
     *
     * Eine Map ist ein Key-Value-Store und ermöglicht den effizienten Zugriff auf beliebige Daten passend zu einem Key.
     * Sie ist außerdem dynamisch, d.h. die Anzahl der zu speichernden Objekte muss bei der Initialisierung nicht wie
     * bei einem Array angegeben werden.
     */

    private HashMap<String, Data> data = new HashMap<String, Data>();

    /**
     * Stores a value next to a city.
     *
     * Note that a city can only be stored once.
     *
     * @param city Name of the city
     * @param value Value to store
     */
    public void addData(String city, int value) {
        data.put(city, new Data(city, value));
    }

    /**
     * Retrieves the stored value for a city
     *
     * @param city Name of the city
     * @return Stored value
     */
    public Data getData(String city) {
        if (!data.containsKey(city)) {
            return null;
        }

        return data.get(city);
    }

}
