public class Data {

    private String city;
    private int value;

    /**
     * Initializes the class with key city and value value.
     *
     * @param city Name of a city.
     * @param value Value must be >= 0.
     */
    public Data(String city, int value) {
        this.city = city;

        if (value >= 0) {
            this.value = value;
        }
    }

    /**
     * Returns the name of the city.
     * @return Name of city
     */
    public String getCity() {
        return city;
    }

    /**
     * Returns the stored value
     * @return Stored value
     */
    public int getValue() {
        return value;
    }
}