public class Aufgabe3 {

    /**
     * • Erklären Sie den Unterschied zwischen dem LIFO und dem FIFO-Prinzip.
     *
     * LIFO bedeutet Last-In-First-Out (Stack). Das Element, das zum Schluss zur Datenstruktur hinzugefügt wurde, wird
     * als erstes auch wieder gelesen.
     *
     * FIFO bedeutet First-In-First-Out (Queue). Das Element, das als Erstes zu Datenstruktur hinzugefügt wurde, wird
     * als erstes auch wieder gelesen.
     *
     * • Muss man bei einer Klasse immer einen Konstruktor implementieren? Wenn nein, was passiert dann?
     *
     * Nein,die Implementierung eines Konstruktors ist optional. Wird darauf verzichtet, so wird ein Default-Konstruktor
     * angelegt. Dieser hat keine Parameter und Sichtbarkeit protected.
     *
     * • Kann man einen Stack auch mit einem Array implementieren? Wenn ja, welche Nachteile ergeben sich daraus?
     *
     * Theoretisch schon, allerdings ist ein Array sehr ineffizient, da es keine dynamische Datenstruktur darstellt
     * und somit muss sich der Programmierer darum kümmern, dass auch Platz für ein weiteres Element zur Verfügung
     * steht.
     */

    /**
     * Checks if the braces in a string are correct.
     *
     * Correct braces are for example (), (()), (())()((())).
     *
     * @param braces String that contains the braces. All characters besides ( and ) are ignored.
     * @return True if the braces are correct and false if not.
     */
    private static boolean check(String braces) {
        CharStack stack = new CharStack();

        for (char c : braces.toCharArray()) {
            if (c == '(') {
                stack.push('(');
            } else if (c == ')') {
                if (!stack.empty()) {
                    stack.pop();
                } else {
                    return false;
                }
            }
        }

        return stack.empty();
    }

}